<script setup lang="ts">
const props = defineProps<{
  nav?: boolean;
}>();
const emit = defineEmits<{
  (e: "search", value: string | undefined): void;
}>();
const { suggest: suggestGene } = useGeneService();

const selected = ref<string>();

const search = () => {
  emit("search", selected.value);
};

const term = ref<string>("");
const items = ref<string[]>([]);
const loading = ref(false);

const refresh = async () => {
  if (!term.value) {
    items.value = [];
    return;
  }
  try {
    loading.value = true;
    items.value = await suggestGene(term.value.trim());
  } finally {
    loading.value = false;
  }
};

const debouncedRefresh = useDebounceFn(refresh, 500);
watch(term, debouncedRefresh);

const combobox = ref();
const inputDOM = computed(() => combobox.value?.$el?.querySelector("input"));
useFocusOnKeyPressed("Cmd+K", inputDOM);
</script>

<template>
  <v-combobox
    ref="combobox"
    v-model="selected"
    v-model:search="term"
    :items="items"
    :loading="loading"
    density="compact"
    :bg-color="props.nav ? 'primary-lighten-2' : undefined"
    prepend-inner-icon="mdi-magnify"
    hide-details
    hide-no-data
    return-object
    placeholder="Search for gene IDs or phenotypes"
    @click:prepend-inner="search"
    @keyup.enter="search"
  >
    <template #loader="{ isActive }">
      <v-progress-linear
        :active="isActive"
        indeterminate
        color="accent"
        :height="2"
      />
    </template>
    <template #append-inner>
      <SearchHelp />
    </template>
    <!-- <template #append-item>
      <div
        v-if="menuShowed"
        v-intersect="(isIntersecting: boolean) => isIntersecting && more()"
      />
    </template> -->
  </v-combobox>
</template>
